`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 10/10/2023 11:18:36 AM
// Design Name: 
// Module Name: stretch
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module stretch(
    input clock,        // 100MHz here
    input reset,
    input [7:0] ticks,  // number of ticks for stretching
    input sigin,       // signal you want to stretch
    output reg sigout  // resulting stretched output
    );

    reg state;
    localparam WAIT=0, COUNT=1;
    reg [7:0] counter;
    wire done = counter == ticks;
    always @ (posedge clock) begin
        if (reset) begin
            state <= WAIT;
            sigout <= 0;
            counter <= 0;
        end
        else case (state)
            WAIT: begin
                sigout <= 0;
                counter <= 0;
                state <= sigin ? COUNT : WAIT; 
            end
            COUNT: begin
                counter <= counter + 1;
                sigout <= 1;
                state <= done ? WAIT : COUNT;
            end
        endcase
    end
endmodule
